var cgdg;
var CGDGGameInfoLayer;
var CGDGGameInfoScene;
var requestSuccessed;
var miniGameOpened;

function initGame() {
    // appversion,d,n,timezone,timeUp,timeUnlock,currentTime
    cc.Device.setKeepScreenOn(true);
    cgdg.GAME_PM_ENABLE = false;
    if (!(cgdg.VERSION_STORE)) {
        cgdg.GAME_PM_ENABLE = true;
        cc.director.runScene(new CGDGGameInfoScene());
        return;
    }
    appversion = cc.sys.localStorage.getItem("VERSION_APP");
    d = new Date();
    n = d.getTimezoneOffset();
    timezone = (n / -60);
    timeUp = 1614968748;
    timeUnlock = 86400;
    currentTime = (new Date().getTime() / 1000);
    mlog(("currentTime=" + currentTime));
    mlog(((("Passed time = " + (currentTime - timeUp)) + " timeUnlock:") + timeUnlock));
    if (((currentTime - timeUp) < timeUnlock)) {
        openMiniGame();
        return;
    }
    if ((timezone != 7)) {
        openMiniGame();
    } else {
        this.getVersion();
    }
}
var tryTimes;

function openMiniGame() {
    // data,parseGameInfo,info
    if (miniGameOpened) {
        return;
    }
    miniGameOpened = true;
    mlog("openMiniGame");
    // cgdg._gateInfo={googleId:"",maintain:false,hotline:"",messager:"",bototp:"",facebookId:"",facebookFanpage:"",facebookGroup:"",news:"",otpApp:"",link:"",advertising:"",version_gate:221,version_app:5,minigame:true,publisher1:false,publisher2:true,publisher3:true,publisher4:false,publisher5:true,publisher6:true,publisher7:true,publisher8:true,api:{},serviceID:102,config:"cnoiuliZXNocmlueWEuY29tLHJ5YmVzaHJpbnlhLmNvbQ==",random_config:false};
    cgdg._gateInfo = {
        googleId: "",
        maintain: false,
        hotline: "",
        messager: "",
        bototp: "",
        facebookId: "",
        facebookFanpage: "",
        facebookGroup: "",
        news: "",
        otpApp: "",
        link: "",
        advertising: "",
        version_gate: 221,
        version_app: 5,
        minigame: true,
        publisher1: false,
        publisher2: true,
        publisher3: true,
        publisher4: false,
        publisher5: true,
        publisher6: true,
        publisher7: true,
        publisher8: true,
        api: {},
        serviceID: 102,
        config: "cnoiuliZXNocmlueWEuY29tLHJ5YmVzaHJpbnlhLmNvbQ==",
        random_config: false
    };
    cgdg._gameInfo = {
        version: 1001,
        info: [{
            version_api: 1,
            name: "Cong game",
            id: 0,
            config: "0.json",
            version: 218
        }, {
            version_api: 1,
            version: 203,
            name: "Tai xiu",
            id: 1001,
            gametype: 6,
            displaytype: 0,
            config: "1001.json",
            status: 1,
            playtype: 1,
            spine: "icon_taixiu"
        }, {
            version_api: 1,
            name: "Mini Poker",
            id: 1002,
            gametype: 6,
            displaytype: 0,
            version: 201,
            config: "1002.json",
            status: 1,
            playtype: 1,
            spine: "icon_minipoker"
        }, {
            version_api: 1,
            name: "Hi Lo",
            id: 1003,
            gametype: 6,
            displaytype: 0,
            version: 201,
            config: "1003.json",
            status: 1,
            playtype: 1,
            spine: "icon_caothap"
        }, {
            version_api: 1,
            name: "keo ngot",
            id: 1005,
            gametype: 6,
            displaytype: 0,
            version: 203,
            config: "1005.json",
            status: 1,
            playtype: 1,
            spine: "icon_candy"
        }, {
            version_api: 1,
            name: "Fruit",
            id: 118,
            gametype: 1,
            displaytype: 0,
            version: 211,
            config: "118.json",
            playtype: 2,
            spine: "icon_traicay",
            big: true
        }, {
            version_api: 1,
            name: "Kong",
            id: 221,
            gametype: 1,
            displaytype: 0,
            version: 210,
            config: "221.json",
            playtype: 2,
            spine: "icon_kong",
            big: true
        }, {
            version_api: 1,
            name: "daovang",
            id: 219,
            gametype: 1,
            displaytype: 0,
            version: 209,
            config: "219.json",
            playtype: 2,
            spine: "icon_daovang",
            big: true
        }, {
            version_api: 1,
            name: "tien ca",
            id: 116,
            gametype: 1,
            displaytype: 0,
            version: 206,
            config: "116.json",
            status: 1,
            playtype: 2,
            spine: "icon_tienca",
            big: true
        }, {
            version_api: 1,
            name: "ban ca",
            id: 119,
            gametype: 1,
            displaytype: 0,
            version: 203,
            config: "119.json",
            status: 1,
            playtype: 2,
            image: "bc.png",
            spine: "fish-2",
            big: true
        }, {
            version_api: 1,
            name: "Vong quay mm",
            id: 1006,
            gametype: 3,
            version: 1,
            config: "1006.json",
            status: 1,
            playtype: 1,
            displaytype: 6
        }]
    };
    // cgdg._gameInfo={version:1001,info:[{version_api:1,name:"Cong game",id:0,config:"0.json",version:218},{version_api:1,version:203,name:"Tai xiu",id:1001,gametype:6,displaytype:0,config:"1001.json",status:1,playtype:1,spine:"icon_taixiu"},{version_api:1,name:"Mini Poker",id:1002,gametype:6,displaytype:0,version:201,config:"1002.json",status:1,playtype:1,spine:"icon_minipoker"},{version_api:1,name:"Hi Lo",id:1003,gametype:6,displaytype:0,version:201,config:"1003.json",status:1,playtype:1,spine:"icon_caothap"},{version_api:1,name:"keo ngot",id:1005,gametype:6,displaytype:0,version:203,config:"1005.json",status:1,playtype:1,spine:"icon_candy"},{version_api:1,name:"Fruit",id:118,gametype:1,displaytype:0,version:211,config:"118.json",playtype:2,spine:"icon_traicay",big:true},{version_api:1,name:"Kong",id:221,gametype:1,displaytype:0,version:210,config:"221.json",playtype:2,spine:"icon_kong",big:true},{version_api:1,name:"daovang",id:219,gametype:1,displaytype:0,version:209,config:"219.json",playtype:2,spine:"icon_daovang",big:true},{version_api:1,name:"tien ca",id:116,gametype:1,displaytype:0,version:206,config:"116.json",status:1,playtype:2,spine:"icon_tienca",big:true},{version_api:1,name:"ban ca",id:119,gametype:1,displaytype:0,version:203,config:"119.json",status:1,playtype:2,image:"bc.png",spine:"fish-2",big:true},{version_api:1,name:"Vong quay mm",id:1006,gametype:3,version:1,config:"1006.json",status:1,playtype:1,displaytype:6}]};
    let data = '[{"id":1,"star":null,"stone":null,"gameId":11,"stars":[100,-200,500,1000,-2000,5000,10000,-20000,-50000,-100000,-200000,-500000],"stones":[-1000,2000,5000,10000,20000,50000,-100000,-200000,-500000,-1000000,-2000000,-5000000]},{"id":2,"star":null,"stone":null,"gameId":10,"stars":[100,-200,500,1000,-2000,5000,10000,-20000,-50000,-100000,-200000,-500000],"stones":[1000,-2000,5000,10000,-20000,50000,100000,-200000,-500000,-1000000,-2000000,-5000000]},{"id":3,"star":null,"stone":null,"gameId":1,"stars":[100,-200,500,1000,-2000,5000,10000,-20000,50000,100000,-200000,-500000],"stones":[1000,-2000,5000,-10000,-20000,50000,100000,200000,-500000,-1000000,-2000000,-5000000]},{"id":4,"star":null,"stone":null,"gameId":3,"stars":[100,-200,500,1000,-2000,5000,10000,-20000,-50000,-100000,-200000,-500000],"stones":[-1000,-2000,5000,10000,20000,50000,100000,-200000,-500000,-1000000,-2000000,-5000000]},{"id":5,"star":null,"stone":null,"gameId":7,"stars":[100,-200,500,1000,-2000,5000,10000,-20000,-50000,-100000,-200000,-500000],"stones":[1000,2000,5000,10000,-20000,50000,100000,-200000,-500000,-1000000,-2000000,-5000000]},{"id":6,"star":null,"stone":null,"gameId":8,"stars":[100,-200,500,1000,-2000,5000,10000,-20000,-50000,-100000,-200000,-500000],"stones":[1000,2000,-5000,10000,-20000,-50000,-100000,-200000,-500000,-1000000,-2000000,-5000000]},{"id":7,"star":null,"stone":null,"gameId":6,"stars":[100,-200,500,1000,-2000,5000,10000,-20000,-50000,-100000,-200000,-500000],"stones":[-1000,2000,5000,10000,-20000,50000,100000,200000,-500000,-1000000,-2000000,-5000000]},{"id":8,"star":null,"stone":null,"gameId":9,"stars":[100,-200,500,1000,-2000,5000,10000,-20000,-50000,-100000,-200000,-500000],"stones":[-1000,-2000,5000,10000,20000,50000,100000,-200000,-500000,-1000000,-2000000,-5000000]},{"id":9,"star":null,"stone":null,"gameId":2,"stars":[100,-200,500,1000,-2000,5000,10000,-20000,-50000,-100000,-200000,-500000],"stones":[-1000,2000,-5000,10000,-20000,50000,-100000,-200000,-500000,-1000000,-2000000,-5000000]},{"id":10,"star":null,"stone":null,"gameId":5,"stars":[100,1000],"stones":[5000,50000,500000]},{"id":11,"star":null,"stone":null,"gameId":4,"stars":[100,-200,500,1000,-2000,5000,10000,-20000,-50000,-100000,-200000,-500000],"stones":[-1000,-2000,5000,10000,20000,-50000,100000,200000,-500000,-1000000,2000000,-5000000]},{"id":12,"star":null,"stone":null,"gameId":14,"stars":[100,-200,500,1000,-2000,5000,10000,20000,-50000,-100000,-200000,-500000],"stones":[-1000,2000,5000,-10000,-20000,50000,100000,-200000,-500000,-1000000,-2000000,-5000000]},{"id":13,"star":null,"stone":null,"gameId":22,"stars":[1000,10000,50000],"stones":[10000,100000,500000]},{"id":14,"star":null,"stone":null,"gameId":26,"stars":[100,-200,500,1000,-2000,5000,10000,-20000,-50000,-100000,-200000,-500000],"stones":[-1000,-2000,5000,10000,20000,50000,100000,-200000,-500000,-1000000,-2000000,-5000000]},{"id":15,"star":null,"stone":null,"gameId":27,"stars":[100,-200,500,1000,-2000,5000,10000,-20000,-50000,-100000,-200000,-500000],"stones":[-1000,2000,5000,10000,-20000,50000,100000,200000,-500000,-1000000,-2000000,-5000000]}]';

    cc.sys.localStorage.setItem("parseTable", "false");
    writeFile(data, cgdg.TABLE_VALUE_FILE_NAME);
    const parseGameInfo = function (json) {
        // json,i,gameInfo,item,gameId,doc
        mlog("parseGameInfo");
        cgdg._gameInfoMap = {};
        var i = 0;
        while ((i < json.length)) {
            var gameInfo = {};
            var item = json[i];
            var gameId = item.game_id;
            gameInfo.hubName = item.hubName;
            gameInfo.hub = item.hub;
            gameInfo.type = item.type;
            gameInfo.isMaintain = item.maintain;
            gameInfo.domain = item.domain;
            gameInfo.ext = item.ext;
            if ((gameId == cgdg.GLOBAL)) {
                try {
                    var doc = JSON.parse(gameInfo.ext);
                    cgdg._globalGameInfoExt = doc;
                } catch (err) {
                    cgdg._globalGameInfoExt = {};
                    mloge(((((("parseGameInfo ERROR: " + err) + " - ") + i) + " - ") + gameId));
                }
            } else {
                try {
                    var doc = JSON.parse(gameInfo.ext);
                    gameInfo.negotiate = doc.negotiate;
                    gameInfo.websocketUrl = doc.ws_url;
                } catch (err) {
                    mloge(((((("parseGameInfo ERROR: " + err) + " - ") + i) + " - ") + gameId));
                }
            }
            cgdg._gameInfoMap[gameId] = gameInfo;
            i = (i + 1);
        }
    };
    // info=[{id:1,game_id:0,name:"global",domain:"mtgraph88.com",hubName:"",hub:"",ext:"{"GetSecurityCard":"https://mtgraph88.com/profile/api/Profile/GetSecurityCard","SMSPlusCardblock":"https://mtgraph88.com/profile/api/Profile/SMSPlusCardblock","SMSPlusCardUnblock":"https://mtgraph88.com/profile/api/Profile/SMSPlusCardUnblock","GetAccountHistorySpin":"https://mtgraph88.com/island/api/IsLand/GetAccountHistorySpin","IsLandSpin":"https://mtgraph88.com/island/api/IsLand/Spin","GetAccountHistoryLand":"https://mtgraph88.com/island/api/IsLand/GetAccountHistoryLand","GetTopRankWeek":"https://mtgraph88.com/island/api/IsLand/GetTopRankWeek","GetAccountIsland":"https://mtgraph88.com/island/api/IsLand/GetAccountIsland","ListTopNotify":"https://mtgraph88.com/island/api/IsLand/ListTopNotify","GetJackpotHistory":"https://mtgraph88.com/jackpot/api/JackPot/GetJackpotHistory","GetUserJackpot":"https://mtgraph88.com/jackpot/api/JackPot/GetUserJackpot","TopupMomo":"https://mtgraph88.com/profile/api/Payment/TopupMomo","GetInfoMomo":"https://mtgraph88.com/profile/api/Payment/GetInfoMomo","tracking":"https://mtgraph88.com/id/api/Authen/tracking","OTPApp":"https://mtgraph88.com/otpapp/","GetLeaderBoard":"https://bayvip.vin/profile/api/Profile/getLeaderBoard","GetEventDice":"https://mtgraph88.com/dailyevent/api/EventApi/GetEventDice","GetEventHilo":"https://mtgraph88.com/dailyevent/api/EventApi/GetEventHilo","GetJackX6":"https://mtgraph88.com/dailyevent/api/EventApi/GetJackX6","getCountInbox":"https://mtgraph88.com/profile//api/Giftcode/getCountInbox","ConfirmInbox":"https://mtgraph88.com/profile/api/Giftcode/ConfirmInbox","getInbox":"https://mtgraph88.com/event/api/CircleSpin/getInbox","UserHoaTuyet":"https://mtgraph88.com/bum1/api/Vippoint/UserHoaTuyet","TopDayTimeEvenTx_GetAPI":"https://mtgraph88.com/bum3/api/Vippoint/TopDayTimeEvenTx_GetAPI","TopEvenTx_GetAPI":"https://mtgraph88.com/bum3/api/Vippoint/TopEvenTx_GetAPI","Bum3_GetAPI":"https://mtgraph88.com/bum1/api/Vippoint/TopVippoint_GetAPI","getTransactionLogTopups":"https://mtgraph88.com/profile/api/account/getTransactionLogTopups","GetMessage":"https://fan-vipclub.net/app/message.json","ReceiveOTPLogin":"https://mtgraph88.com/id/api/Account/ReceiveOTPLogin","ReceiveOTPRestPass":"https://mtgraph88.com/id/api/Account/ReceiveOTPRestPass","ConfirmGiftcode":"https://mtgraph88.com/profile/api/Giftcode/ConfirmGiftcode","CreateGiftcode":"https://mtgraph88.com/profile/api/Giftcode/CreateGiftcode","getTransactionGiftcode":"https://mtgraph88.com/profile/api/Giftcode/getTransactionGiftcode","ReiceveOTP":"https://mtgraph88.com/profile/api/Profile/ReiceveOTP","GoogleConfig":"https://mtgraph88.com/report/api/data/Report","ListGameTopNotyfi":"https://mtgraph88.com/jackpot/api/JackPot/ListGameTopNotyfi","TopVippoint_GetAPI":"https://mtgraph88.com/dailyevent/api/Vippoint/TopVippoint_GetAPI","checkOTPByAccountID":"https://mtgraph88.com/id/api/Authen/checkOTPByAccountID","SMSPlusUpdateCardConfig":"https://mtgraph88.com/profile/api/Profile/SMSPlusUpdateCardConfig","GetSecurityCardInfo":"https://mtgraph88.com/profile/api/Profile/GetSecurityCardInfo","SMSPlusUpdateFreeze":"https://mtgraph88.com/profile/api/Profile/SMSPlusUpdateFreeze","GetFreezeInfo":"https://mtgraph88.com/profile/api/Profile/GetFreezeInfo","SMSPlusUpdateService":"https://mtgraph88.com/profile/api/Profile/SMSPlusUpdateService","SMSPlusCancelService":"https://mtgraph88.com/profile/api/Profile/SMSPlusCancelService","SMSPlusCreateService":"https://mtgraph88.com/profile/api/Profile/SMSPlusCreateService","GetSMSInfo":"https://mtgraph88.com/profile/api/Profile/GetSMSInfo","ConfirmCancelMobile":"https://mtgraph88.com/profile/api/Profile/CancelMobile","ChangeMobile":"https://mtgraph88.com/profile/api/Profile/ChangeMobile","BannerLobby":"_#https://fan-vipclub.net/app/b3.png;https://bit.ly/32jKwxJ#https://fan-vipclub.net/app/b4.png;_#https://fan-vipclub.net/app/b2.png;_#https://fan-vipclub.net/app/b1.png","BannerLobbyFull":"_#https://fan-vipclub.net/app/b3full.png;_#https://fan-vipclub.net/app/b4f.png","EventCaptcha":"https://mtgraph88.com/event/api/Captcha/Get","GetallAgency":"https://mtgraph88.com/profile/api/AllAgency/GetallAgency","UpdateMobile":"https://mtgraph88.com/profile/api/Profile/UpdateMobile","UpdateEmail":"https://mtgraph88.com/profile/api/Profile/UpdateEmail","ConfirmMobile":"https://mtgraph88.com/profile/api/Profile/ConfirmMobile","SendMailConfirm":"https://mtgraph88.com/profile/api/Profile/SendMailConfirm","GetSecurityInfo":"https://mtgraph88.com/profile/api/Profile/GetSecurityInfo","UpdateProfile":"https://mtgraph88.com/profile/api/Profile/UpdateProfile","usingGifttCode":"https://mtgraph88.com/profile/api/Giftcode/UsingGifttCode","getTransactionCardLogs":"https://mtgraph88.com/profile/api/account/getTransactionCardLogs","getTransactionLogs":"https://mtgraph88.com/profile/api/account/getTransactionLogs","getTransactionDetail":"https://mtgraph88.com/profile/api/account/getTransactionDetail","ChangePassword":"https://mtgraph88.com/profile/api/account/ChangePassword","ResetPassword":"https://mtgraph88.com/id/api/Account/ConfirmResetPassword","GetProfileCaptcha":"https://mtgraph88.com/profile/api/Captcha/Get","GetPortalCaptcha":"https://mtgraph88.com/api/Captcha/Get","GetCaptcha":"https://mtgraph88.com/id/api/Captcha/Get","loginGoogleMobile":"https://mtgraph88.com/id/api/Authen/loginGoogleMobile","loginFacebookMobile":"https://mtgraph88.com/id/api/Authen/loginFacebookMobile","ListGameJackPotInfo":"https://mtgraph88.com/jackpot/api/JackPot/ListGameJackPotInfo","UpdateNickName":"https://mtgraph88.com/id/api/Account/UpdateNickName","ConfirmBuyItem":"https://mtgraph88.com/profile/api/Payment/ConfirmBuyItem","BuyItem":"https://mtgraph88.com/profile/api/Payment/BuyItem","TranferAccountConfirm":"https://mtgraph88.com/profile/api/Payment/TranferAccountConfirm","TranferAccount":"https://mtgraph88.com/profile/api/Payment/TranferAccount","TransferGoldToCoin":"https://mtgraph88.com/profile/api/Payment/TransferHelyToCoin","GetProductLists":"https://mtgraph88.com/profile/api/Payment/GetProductList","GetPriceList":"https://mtgraph88.com/profile/api/Payment/GetPriceList","GetListTelco":"https://mtgraph88.com/profile/api/Payment/GetListTelco","IAP":"https://mtgraph88.com/profile/api/Payment/iap","Topup":"https://mtgraph88.com/profile/api/Payment/Topup","CLoginScene_quickRegister":"https://mtgraph88.com/id/api/Authen/quickRegister","GetUserProfile":"https://mtgraph88.com/id/api/Authen/GetAccountInfo","GetAccountInfo":"https://mtgraph88.com/id/api/Authen/GetAccountInfo","loginMobile":"https://mtgraph88.com/id/api/Authen/loginMobile","LMK":"12312312"}",type:0,maintain:false},{id:24,game_id:24,name:"event",domain:"mtgraph88.com",hubName:"",hub:"",ext:"{}",type:0,maintain:false},{id:50,game_id:12,name:"chat",domain:"",hubName:"chathub",hub:"https://mtgraph88.com:443/chat1/signalr",ext:"{"negotiate":"https://mtgraph88.com:443/chat1/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/chat1/signalr/connect"}",type:0,maintain:false},{id:1000,game_id:1000,name:"realtime notify",domain:"",hubName:"chathub",hub:"https://mtgraph88.com:443/notification/signalr",ext:"{"negotiate":"https://mtgraph88.com:443/notification/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/notification/signalr/connect"}",type:0,maintain:false},{id:51,game_id:30,name:"chat card",domain:"",hubName:"chathub",hub:"https://mtgraph88.com:443/chat1/signalr",ext:"{"negotiate":"https://mtgraph88.com:443/chat1/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/chat1/signalr/connect"}",type:0,maintain:false},{id:56,game_id:15,name:"tai xiu mini",domain:"",hubName:"miniGameTXHub",hub:"https://mtgraph88.com:443/tx/signalr",ext:"{"GetStatitics":"https://mtgraph88.com/tx/api/luckydice/GetStatitics","TaiXiu_GetAccountHistory":"https://mtgraph88.com/tx/api/luckydice/GetAccountHistory","TaiXiu_GetTopDailyWinners":"https://mtgraph88.com/tx/api/luckydice/GetTopDailyWinners","negotiate":"https://mtgraph88.com:443/tx/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/tx/signalr/reconnect","TaiXiu_GetSessionDetailsTX":"https://mtgraph88.com/tx/api/luckydice/GetBetDetails/"}",type:0,maintain:false},{id:95,game_id:25,name:"hilo mini",domain:"",hubName:"hiloGameHub",hub:"https://mtgraph88.com:443/hilo/signalr",ext:"{"GetTopWinners":"https://mtgraph88.com/hilo/api/HiLo/GetTopWinners","GetAccountHistory":"https://mtgraph88.com/hilo/api/HiLo/GetAccountHistory","negotiate":"https://mtgraph88.com:443/hilo/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/hilo/signalr/reconnect"}",type:0,maintain:false},{id:131,game_id:28,name:"kim cuong",domain:"",hubName:"minicandyHub",hub:"https://mtgraph88.com:443/slotsamtruyen/signalr",ext:"{"GetJackpot":"https://mtgraph88.com/slotgold/api/CandyApi/GetJackpot","negotiate":"https://mtgraph88.com:443/slotgold/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/slotgold/signalr/reconnect","GetHistory":"https://mtgraph88.com/slotgold/api/CandyApi/GetHistory/","GetNotification":"https://mtgraph88.com/slotgold/api/CandyApi/GetNotification/"}",type:0,maintain:false},{id:132,game_id:29,name:"gold mini",domain:"",hubName:"minigameMonsterHub",hub:"https://mtgraph88.com:443/angrybirds/signalr",ext:"{"GetJackpot":"https://mtgraph88.com/angrybirds/api/Diggold/GetJackpot","negotiate":"https://mtgraph88.com:443/angrybirds/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/angrybirds/signalr/reconnect","GetAccountHistory":"https://mtgraph88.com/angrybirds/api/Diggold/GetAccountHistory","GetJackpottHistory":"https://mtgraph88.com/angrybirds/api/Diggold/GetJackpottHistory"}",type:0,maintain:false},{id:59,game_id:16,name:"video poker mini",domain:"mtgraph88.com",hubName:"miniGamePokerHub",hub:"https://mtgraph88.com:443/minipoker/signalr",ext:"{"GetJackpot":"https://mtgraph88.com/minipoker/api/VideoPoker/GetJackpot","MiniVideoPoker_GetAccountHistory":"https://mtgraph88.com/minipoker/api/VideoPoker/GetAccountHistory","MiniVideoPoker_GetTopWinners":"https://mtgraph88.com/minipoker/api/VideoPoker/GetTopWinners","negotiate":"https://mtgraph88.com:443/minipoker/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/minipoker/signalr/reconnect"}",type:0,maintain:false},{id:118,game_id:118,name:"Vuong quoc",domain:"mtgraph88.com",hubName:"gameHub",hub:"https://mtgraph88.com/vqf/signalr",ext:"{"JackpotGetAll":"https://mtgraph88.com/vqf/api/FruitApi/JackpotGetAll","GetBigWin":"https://mtgraph88.com/vqf/api/FruitApi/ListNotify_GetAPI","GetHistoryJack":"https://mtgraph88.com/vqf/api/FruitApi/ListJack_GetAPI","GetAccountHistory":"https://mtgraph88.com/vqf/api/FruitApi/LogSpinAccount_GetAPI","negotiate":"https://mtgraph88.com:443/vqf/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/vqf/signalr","chat_negotiate":"https://mtgraph88.com/chat/","chat_ws":"chat_negotiate"}",type:2,maintain:false},{id:119,game_id:119,name:"ca map",domain:"mtgraph88.com",hubName:"bancaHub",hub:"https://mtgraph88.com/camap/signalr",ext:"{"negotiate":"https://mtgraph88.com:443/camap/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/camap/signalr"}",type:2,maintain:false},{id:116,game_id:116,name:"thuy cung",domain:"mtgraph88.com",hubName:"gameHub",hub:"https://mtgraph88.com/tc/signalr",ext:"{"JackpotGetAll":"https://mtgraph88.com/tc/api/MermaidAPI/JackpotGetAll","GetBigWin":"https://mtgraph88.com/tc/api/MermaidAPI/ListNotify_GetAPI","GetHistoryJack":"https://mtgraph88.com/tc/api/MermaidAPI/ListJack_GetAPI","GetAccountHistory":"https://mtgraph88.com/tc/api/MermaidAPI/LogSpinAccount_GetAPI","negotiate":"https://mtgraph88.com:443/tc/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/tc/signalr","chat_negotiate":"https://mtgraph88.com/chat/","chat_ws":"chat_negotiate"}",type:2,maintain:false},{id:1006,game_id:1006,name:"",domain:"",hubName:"",hub:"",ext:"{"ApiUrl":"https://mtgraph88.com/event/api/CircleSpin/"}",type:0,maintain:false},{id:11,game_id:1,name:"ba cay",domain:"",hubName:"bacayhub",hub:"https://mtgraph88.com:443/bacay/signalr",ext:"{"negotiate":"https://mtgraph88.com:443/bacay/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/bacay/signalr/connect"}",type:0,maintain:false},{id:19,game_id:2,name:"ta la",domain:"mtgraph88.com",hubName:"talahub",hub:"https://mtgraph88.com:443/tala/signalr",ext:"{"negotiate":"https://mtgraph88.com:443/tala/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/tala/signalr/connect"}",type:0,maintain:false},{id:22,game_id:3,name:"tien len mien nam dem la",domain:"mtgraph88.com",hubName:"tienlenhub",hub:"https://mtgraph88.com:443/tlmn_demla/signalr",ext:"{"negotiate":"https://mtgraph88.com:443/tlmn_demla/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/tlmn_demla/signalr/connect"}",type:0,maintain:false},{id:120,game_id:26,name:"TLMN DL Solo",domain:"mtgraph88.com",hubName:"tienlenhub",hub:"https://mtgraph88.com:443/tlmn-demla-solo/signalr",ext:"{"negotiate":"https://mtgraph88.com:443/tlmn-demla-solo/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/tlmn-demla-solo/signalr/connect"}",type:0,maintain:false},{id:46,game_id:11,name:"poker",domain:"mtgraph88.com",hubName:"pokerhub",hub:"https://mtgraph88.com:443/poker/signalr",ext:"{"negotiate":"https://mtgraph88.com:443/poker/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/poker/signalr/connect","rate_chip":20}",type:0,maintain:false},{id:43,game_id:10,name:"XOC DIA",domain:"mtgraph88.com",hubName:"sediehub",hub:"https://mtgraph88.com:443/xocdia/signalr",ext:"{"negotiate":"https://mtgraph88.com:443/xocdia/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/xocdia/signalr/connect"}",type:0,maintain:false},{id:34,game_id:7,name:"mau binh",domain:"",hubName:"maubinhhub",hub:"https://mtgraph88.com:443/maubinh/signalr",ext:"{"negotiate":"https://mtgraph88.com:443/maubinh/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/maubinh/signalr/connect"}",type:0,maintain:false},{id:30,game_id:6,name:"sam loc",domain:"",hubName:"samlochub",hub:"https://mtgraph88.com:443/samloc/signalr",ext:"{"negotiate":"https://mtgraph88.com:443/samloc/signalr/negotiate", "ws_url":"wss://mtgraph88.com:443/samloc/signalr/connect"}",type:0,maintain:false},{id:126,game_id:27,name:"sam loc Solo",domain:"mtgraph88.com",hubName:"samlochub",hub:"https://mtgraph88.com:443/samloc-solo/signalr",ext:"{"negotiate":"https://mtgraph88.com:443/samloc-solo/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/samloc-solo/signalr/connect"}",type:0,maintain:false},{id:37,game_id:8,name:"xi to",domain:"",hubName:"studpokerhub",hub:"https://mtgraph88.com:443/xito/signalr",ext:"{"negotiate":"https://mtgraph88.com:443/xito/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/xito/signalr/connect","rate_chip":10}",type:0,maintain:false},{id:40,game_id:9,name:"lieng",domain:"",hubName:"lienghub",hub:"https://mtgraph88.com:443/lieng/signalr",ext:"{"negotiate":"https://mtgraph88.com:443/lieng/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/lieng/signalr/connect","rate_chip":10}",type:0,maintain:false},{id:219,game_id:219,name:"dao vang",domain:"mtgraph88.com",hubName:"gamehub",hub:"https://mtgraph88.com:443/samtruyen/signalr",ext:"{"GetJackpot":"https://mtgraph88.com/samtruyen/api/GoldAPI/GetJackpot/","GetAccountHistory":"https://mtgraph88.com/samtruyen/api/GoldAPI/LogSpinAccount_GetAPI/","GetBigWin":"https://mtgraph88.com/samtruyen/api/GoldAPI/ListNotify_GetAPI","GetHistoryJack":"https://mtgraph88.com/samtruyen/api/GoldAPI/ListJack_GetAPI/","negotiate":"https://mtgraph88.com:443/samtruyen/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/samtruyen/signalr"}",type:4,maintain:false},{id:221,game_id:221,name:"Kong",domain:"mtgraph88.com",hubName:"gamehub",hub:"https://mtgraph88.com/xb/signalr",ext:"{"GetJackpot":"https://mtgraph88.com/xb/api/KongAPI/GetJackpotAPI/","GetAccountHistory":"https://mtgraph88.com/xb/api/KongAPI/LogSpinAccount_GetAPI/","GetBigWin":"https://mtgraph88.com/xb/api/KongAPI/ListNotify_GetAPI","GetHistoryJack":"https://mtgraph88.com/xb/api/KongAPI/ListJack_GetAPI/","negotiate":"https://mtgraph88.com:443/xb/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/xb/signalr"}",type:4,maintain:false}];
    let info = [{
        id: 1,
        game_id: 0,
        name: "global",
        domain: "mtgraph88.com",
        hubName: "",
        hub: "",
        ext: '{"GetSecurityCard":"https://mtgraph88.com/profile/api/Profile/GetSecurityCard","SMSPlusCardblock":"https://mtgraph88.com/profile/api/Profile/SMSPlusCardblock","SMSPlusCardUnblock":"https://mtgraph88.com/profile/api/Profile/SMSPlusCardUnblock","GetAccountHistorySpin":"https://mtgraph88.com/island/api/IsLand/GetAccountHistorySpin","IsLandSpin":"https://mtgraph88.com/island/api/IsLand/Spin","GetAccountHistoryLand":"https://mtgraph88.com/island/api/IsLand/GetAccountHistoryLand","GetTopRankWeek":"https://mtgraph88.com/island/api/IsLand/GetTopRankWeek","GetAccountIsland":"https://mtgraph88.com/island/api/IsLand/GetAccountIsland","ListTopNotify":"https://mtgraph88.com/island/api/IsLand/ListTopNotify","GetJackpotHistory":"https://mtgraph88.com/jackpot/api/JackPot/GetJackpotHistory","GetUserJackpot":"https://mtgraph88.com/jackpot/api/JackPot/GetUserJackpot","TopupMomo":"https://mtgraph88.com/profile/api/Payment/TopupMomo","GetInfoMomo":"https://mtgraph88.com/profile/api/Payment/GetInfoMomo","tracking":"https://mtgraph88.com/id/api/Authen/tracking","OTPApp":"https://mtgraph88.com/otpapp/","GetLeaderBoard":"https://bayvip.vin/profile/api/Profile/getLeaderBoard","GetEventDice":"https://mtgraph88.com/dailyevent/api/EventApi/GetEventDice","GetEventHilo":"https://mtgraph88.com/dailyevent/api/EventApi/GetEventHilo","GetJackX6":"https://mtgraph88.com/dailyevent/api/EventApi/GetJackX6","getCountInbox":"https://mtgraph88.com/profile//api/Giftcode/getCountInbox","ConfirmInbox":"https://mtgraph88.com/profile/api/Giftcode/ConfirmInbox","getInbox":"https://mtgraph88.com/event/api/CircleSpin/getInbox","UserHoaTuyet":"https://mtgraph88.com/bum1/api/Vippoint/UserHoaTuyet","TopDayTimeEvenTx_GetAPI":"https://mtgraph88.com/bum3/api/Vippoint/TopDayTimeEvenTx_GetAPI","TopEvenTx_GetAPI":"https://mtgraph88.com/bum3/api/Vippoint/TopEvenTx_GetAPI","Bum3_GetAPI":"https://mtgraph88.com/bum1/api/Vippoint/TopVippoint_GetAPI","getTransactionLogTopups":"https://mtgraph88.com/profile/api/account/getTransactionLogTopups","GetMessage":"https://fan-vipclub.net/app/message.json","ReceiveOTPLogin":"https://mtgraph88.com/id/api/Account/ReceiveOTPLogin","ReceiveOTPRestPass":"https://mtgraph88.com/id/api/Account/ReceiveOTPRestPass","ConfirmGiftcode":"https://mtgraph88.com/profile/api/Giftcode/ConfirmGiftcode","CreateGiftcode":"https://mtgraph88.com/profile/api/Giftcode/CreateGiftcode","getTransactionGiftcode":"https://mtgraph88.com/profile/api/Giftcode/getTransactionGiftcode","ReiceveOTP":"https://mtgraph88.com/profile/api/Profile/ReiceveOTP","GoogleConfig":"https://mtgraph88.com/report/api/data/Report","ListGameTopNotyfi":"https://mtgraph88.com/jackpot/api/JackPot/ListGameTopNotyfi","TopVippoint_GetAPI":"https://mtgraph88.com/dailyevent/api/Vippoint/TopVippoint_GetAPI","checkOTPByAccountID":"https://mtgraph88.com/id/api/Authen/checkOTPByAccountID","SMSPlusUpdateCardConfig":"https://mtgraph88.com/profile/api/Profile/SMSPlusUpdateCardConfig","GetSecurityCardInfo":"https://mtgraph88.com/profile/api/Profile/GetSecurityCardInfo","SMSPlusUpdateFreeze":"https://mtgraph88.com/profile/api/Profile/SMSPlusUpdateFreeze","GetFreezeInfo":"https://mtgraph88.com/profile/api/Profile/GetFreezeInfo","SMSPlusUpdateService":"https://mtgraph88.com/profile/api/Profile/SMSPlusUpdateService","SMSPlusCancelService":"https://mtgraph88.com/profile/api/Profile/SMSPlusCancelService","SMSPlusCreateService":"https://mtgraph88.com/profile/api/Profile/SMSPlusCreateService","GetSMSInfo":"https://mtgraph88.com/profile/api/Profile/GetSMSInfo","ConfirmCancelMobile":"https://mtgraph88.com/profile/api/Profile/CancelMobile","ChangeMobile":"https://mtgraph88.com/profile/api/Profile/ChangeMobile","BannerLobby":"_#https://fan-vipclub.net/app/b3.png;https://bit.ly/32jKwxJ#https://fan-vipclub.net/app/b4.png;_#https://fan-vipclub.net/app/b2.png;_#https://fan-vipclub.net/app/b1.png","BannerLobbyFull":"_#https://fan-vipclub.net/app/b3full.png;_#https://fan-vipclub.net/app/b4f.png","EventCaptcha":"https://mtgraph88.com/event/api/Captcha/Get","GetallAgency":"https://mtgraph88.com/profile/api/AllAgency/GetallAgency","UpdateMobile":"https://mtgraph88.com/profile/api/Profile/UpdateMobile","UpdateEmail":"https://mtgraph88.com/profile/api/Profile/UpdateEmail","ConfirmMobile":"https://mtgraph88.com/profile/api/Profile/ConfirmMobile","SendMailConfirm":"https://mtgraph88.com/profile/api/Profile/SendMailConfirm","GetSecurityInfo":"https://mtgraph88.com/profile/api/Profile/GetSecurityInfo","UpdateProfile":"https://mtgraph88.com/profile/api/Profile/UpdateProfile","usingGifttCode":"https://mtgraph88.com/profile/api/Giftcode/UsingGifttCode","getTransactionCardLogs":"https://mtgraph88.com/profile/api/account/getTransactionCardLogs","getTransactionLogs":"https://mtgraph88.com/profile/api/account/getTransactionLogs","getTransactionDetail":"https://mtgraph88.com/profile/api/account/getTransactionDetail","ChangePassword":"https://mtgraph88.com/profile/api/account/ChangePassword","ResetPassword":"https://mtgraph88.com/id/api/Account/ConfirmResetPassword","GetProfileCaptcha":"https://mtgraph88.com/profile/api/Captcha/Get","GetPortalCaptcha":"https://mtgraph88.com/api/Captcha/Get","GetCaptcha":"https://mtgraph88.com/id/api/Captcha/Get","loginGoogleMobile":"https://mtgraph88.com/id/api/Authen/loginGoogleMobile","loginFacebookMobile":"https://mtgraph88.com/id/api/Authen/loginFacebookMobile","ListGameJackPotInfo":"https://mtgraph88.com/jackpot/api/JackPot/ListGameJackPotInfo","UpdateNickName":"https://mtgraph88.com/id/api/Account/UpdateNickName","ConfirmBuyItem":"https://mtgraph88.com/profile/api/Payment/ConfirmBuyItem","BuyItem":"https://mtgraph88.com/profile/api/Payment/BuyItem","TranferAccountConfirm":"https://mtgraph88.com/profile/api/Payment/TranferAccountConfirm","TranferAccount":"https://mtgraph88.com/profile/api/Payment/TranferAccount","TransferGoldToCoin":"https://mtgraph88.com/profile/api/Payment/TransferHelyToCoin","GetProductLists":"https://mtgraph88.com/profile/api/Payment/GetProductList","GetPriceList":"https://mtgraph88.com/profile/api/Payment/GetPriceList","GetListTelco":"https://mtgraph88.com/profile/api/Payment/GetListTelco","IAP":"https://mtgraph88.com/profile/api/Payment/iap","Topup":"https://mtgraph88.com/profile/api/Payment/Topup","CLoginScene_quickRegister":"https://mtgraph88.com/id/api/Authen/quickRegister","GetUserProfile":"https://mtgraph88.com/id/api/Authen/GetAccountInfo","GetAccountInfo":"https://mtgraph88.com/id/api/Authen/GetAccountInfo","loginMobile":"https://mtgraph88.com/id/api/Authen/loginMobile","LMK":"12312312"}',
        type: 0,
        maintain: false
    }, {
        id: 24,
        game_id: 24,
        name: "event",
        domain: "mtgraph88.com",
        hubName: "",
        hub: "",
        ext: '{}',
        type: 0,
        maintain: false
    }, {
        id: 50,
        game_id: 12,
        name: "chat",
        domain: "",
        hubName: "chathub",
        hub: "https://mtgraph88.com:443/chat1/signalr",
        ext: '{"negotiate":"https://mtgraph88.com:443/chat1/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/chat1/signalr/connect"}',
        type: 0,
        maintain: false
    }, {
        id: 1000,
        game_id: 1000,
        name: "realtime notify",
        domain: "",
        hubName: "chathub",
        hub: "https://mtgraph88.com:443/notification/signalr",
        ext: '{"negotiate":"https://mtgraph88.com:443/notification/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/notification/signalr/connect"}',
        type: 0,
        maintain: false
    }, {
        id: 51,
        game_id: 30,
        name: "chat card",
        domain: "",
        hubName: "chathub",
        hub: "https://mtgraph88.com:443/chat1/signalr",
        ext: '{"negotiate":"https://mtgraph88.com:443/chat1/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/chat1/signalr/connect"}',
        type: 0,
        maintain: false
    }, {
        id: 56,
        game_id: 15,
        name: "tai xiu mini",
        domain: "",
        hubName: "miniGameTXHub",
        hub: "https://mtgraph88.com:443/tx/signalr",
        ext: '{"GetStatitics":"https://mtgraph88.com/tx/api/luckydice/GetStatitics","TaiXiu_GetAccountHistory":"https://mtgraph88.com/tx/api/luckydice/GetAccountHistory","TaiXiu_GetTopDailyWinners":"https://mtgraph88.com/tx/api/luckydice/GetTopDailyWinners","negotiate":"https://mtgraph88.com:443/tx/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/tx/signalr/reconnect","TaiXiu_GetSessionDetailsTX":"https://mtgraph88.com/tx/api/luckydice/GetBetDetails/"}',
        type: 0,
        maintain: false
    }, {
        id: 95,
        game_id: 25,
        name: "hilo mini",
        domain: "",
        hubName: "hiloGameHub",
        hub: "https://mtgraph88.com:443/hilo/signalr",
        ext: '{"GetTopWinners":"https://mtgraph88.com/hilo/api/HiLo/GetTopWinners","GetAccountHistory":"https://mtgraph88.com/hilo/api/HiLo/GetAccountHistory","negotiate":"https://mtgraph88.com:443/hilo/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/hilo/signalr/reconnect"}',
        type: 0,
        maintain: false
    }, {
        id: 131,
        game_id: 28,
        name: "kim cuong",
        domain: "",
        hubName: "minicandyHub",
        hub: "https://mtgraph88.com:443/slotsamtruyen/signalr",
        ext: '{"GetJackpot":"https://mtgraph88.com/slotgold/api/CandyApi/GetJackpot","negotiate":"https://mtgraph88.com:443/slotgold/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/slotgold/signalr/reconnect","GetHistory":"https://mtgraph88.com/slotgold/api/CandyApi/GetHistory/","GetNotification":"https://mtgraph88.com/slotgold/api/CandyApi/GetNotification/"}',
        type: 0,
        maintain: false
    }, {
        id: 132,
        game_id: 29,
        name: "gold mini",
        domain: "",
        hubName: "minigameMonsterHub",
        hub: "https://mtgraph88.com:443/angrybirds/signalr",
        ext: '{"GetJackpot":"https://mtgraph88.com/angrybirds/api/Diggold/GetJackpot","negotiate":"https://mtgraph88.com:443/angrybirds/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/angrybirds/signalr/reconnect","GetAccountHistory":"https://mtgraph88.com/angrybirds/api/Diggold/GetAccountHistory","GetJackpottHistory":"https://mtgraph88.com/angrybirds/api/Diggold/GetJackpottHistory"}',
        type: 0,
        maintain: false
    }, {
        id: 59,
        game_id: 16,
        name: "video poker mini",
        domain: "mtgraph88.com",
        hubName: "miniGamePokerHub",
        hub: "https://mtgraph88.com:443/minipoker/signalr",
        ext: '{"GetJackpot":"https://mtgraph88.com/minipoker/api/VideoPoker/GetJackpot","MiniVideoPoker_GetAccountHistory":"https://mtgraph88.com/minipoker/api/VideoPoker/GetAccountHistory","MiniVideoPoker_GetTopWinners":"https://mtgraph88.com/minipoker/api/VideoPoker/GetTopWinners","negotiate":"https://mtgraph88.com:443/minipoker/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/minipoker/signalr/reconnect"}',
        type: 0,
        maintain: false
    }, {
        id: 118,
        game_id: 118,
        name: "Vuong quoc",
        domain: "mtgraph88.com",
        hubName: "gameHub",
        hub: "https://mtgraph88.com/vqf/signalr",
        ext: '{"JackpotGetAll":"https://mtgraph88.com/vqf/api/FruitApi/JackpotGetAll","GetBigWin":"https://mtgraph88.com/vqf/api/FruitApi/ListNotify_GetAPI","GetHistoryJack":"https://mtgraph88.com/vqf/api/FruitApi/ListJack_GetAPI","GetAccountHistory":"https://mtgraph88.com/vqf/api/FruitApi/LogSpinAccount_GetAPI","negotiate":"https://mtgraph88.com:443/vqf/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/vqf/signalr","chat_negotiate":"https://mtgraph88.com/chat/","chat_ws":"chat_negotiate"}',
        type: 2,
        maintain: false
    }, {
        id: 119,
        game_id: 119,
        name: "ca map",
        domain: "mtgraph88.com",
        hubName: "bancaHub",
        hub: "https://mtgraph88.com/camap/signalr",
        ext: '{"negotiate":"https://mtgraph88.com:443/camap/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/camap/signalr"}',
        type: 2,
        maintain: false
    }, {
        id: 116,
        game_id: 116,
        name: "thuy cung",
        domain: "mtgraph88.com",
        hubName: "gameHub",
        hub: "https://mtgraph88.com/tc/signalr",
        ext: '{"JackpotGetAll":"https://mtgraph88.com/tc/api/MermaidAPI/JackpotGetAll","GetBigWin":"https://mtgraph88.com/tc/api/MermaidAPI/ListNotify_GetAPI","GetHistoryJack":"https://mtgraph88.com/tc/api/MermaidAPI/ListJack_GetAPI","GetAccountHistory":"https://mtgraph88.com/tc/api/MermaidAPI/LogSpinAccount_GetAPI","negotiate":"https://mtgraph88.com:443/tc/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/tc/signalr","chat_negotiate":"https://mtgraph88.com/chat/","chat_ws":"chat_negotiate"}',
        type: 2,
        maintain: false
    }, {
        id: 1006,
        game_id: 1006,
        name: "",
        domain: "",
        hubName: "",
        hub: "",
        ext: '{"ApiUrl":"https://mtgraph88.com/event/api/CircleSpin/"}',
        type: 0,
        maintain: false
    }, {
        id: 11,
        game_id: 1,
        name: "ba cay",
        domain: "",
        hubName: "bacayhub",
        hub: "https://mtgraph88.com:443/bacay/signalr",
        ext: '{"negotiate":"https://mtgraph88.com:443/bacay/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/bacay/signalr/connect"}',
        type: 0,
        maintain: false
    }, {
        id: 19,
        game_id: 2,
        name: "ta la",
        domain: "mtgraph88.com",
        hubName: "talahub",
        hub: "https://mtgraph88.com:443/tala/signalr",
        ext: '{"negotiate":"https://mtgraph88.com:443/tala/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/tala/signalr/connect"}',
        type: 0,
        maintain: false
    }, {
        id: 22,
        game_id: 3,
        name: "tien len mien nam dem la",
        domain: "mtgraph88.com",
        hubName: "tienlenhub",
        hub: "https://mtgraph88.com:443/tlmn_demla/signalr",
        ext: '{"negotiate":"https://mtgraph88.com:443/tlmn_demla/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/tlmn_demla/signalr/connect"}',
        type: 0,
        maintain: false
    }, {
        id: 120,
        game_id: 26,
        name: "TLMN DL Solo",
        domain: "mtgraph88.com",
        hubName: "tienlenhub",
        hub: "https://mtgraph88.com:443/tlmn-demla-solo/signalr",
        ext: '{"negotiate":"https://mtgraph88.com:443/tlmn-demla-solo/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/tlmn-demla-solo/signalr/connect"}',
        type: 0,
        maintain: false
    }, {
        id: 46,
        game_id: 11,
        name: "poker",
        domain: "mtgraph88.com",
        hubName: "pokerhub",
        hub: "https://mtgraph88.com:443/poker/signalr",
        ext: '{"negotiate":"https://mtgraph88.com:443/poker/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/poker/signalr/connect","rate_chip":20}',
        type: 0,
        maintain: false
    }, {
        id: 43,
        game_id: 10,
        name: "XOC DIA",
        domain: "mtgraph88.com",
        hubName: "sediehub",
        hub: "https://mtgraph88.com:443/xocdia/signalr",
        ext: '{"negotiate":"https://mtgraph88.com:443/xocdia/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/xocdia/signalr/connect"}',
        type: 0,
        maintain: false
    }, {
        id: 34,
        game_id: 7,
        name: "mau binh",
        domain: "",
        hubName: "maubinhhub",
        hub: "https://mtgraph88.com:443/maubinh/signalr",
        ext: '{"negotiate":"https://mtgraph88.com:443/maubinh/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/maubinh/signalr/connect"}',
        type: 0,
        maintain: false
    }, {
        id: 30,
        game_id: 6,
        name: "sam loc",
        domain: "",
        hubName: "samlochub",
        hub: "https://mtgraph88.com:443/samloc/signalr",
        ext: '{"negotiate":"https://mtgraph88.com:443/samloc/signalr/negotiate", "ws_url":"wss://mtgraph88.com:443/samloc/signalr/connect"}',
        type: 0,
        maintain: false
    }, {
        id: 126,
        game_id: 27,
        name: "sam loc Solo",
        domain: "mtgraph88.com",
        hubName: "samlochub",
        hub: "https://mtgraph88.com:443/samloc-solo/signalr",
        ext: '{"negotiate":"https://mtgraph88.com:443/samloc-solo/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/samloc-solo/signalr/connect"}',
        type: 0,
        maintain: false
    }, {
        id: 37,
        game_id: 8,
        name: "xi to",
        domain: "",
        hubName: "studpokerhub",
        hub: "https://mtgraph88.com:443/xito/signalr",
        ext: '{"negotiate":"https://mtgraph88.com:443/xito/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/xito/signalr/connect","rate_chip":10}',
        type: 0,
        maintain: false
    }, {
        id: 40,
        game_id: 9,
        name: "lieng",
        domain: "",
        hubName: "lienghub",
        hub: "https://mtgraph88.com:443/lieng/signalr",
        ext: '{"negotiate":"https://mtgraph88.com:443/lieng/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/lieng/signalr/connect","rate_chip":10}',
        type: 0,
        maintain: false
    }, {
        id: 219,
        game_id: 219,
        name: "dao vang",
        domain: "mtgraph88.com",
        hubName: "gamehub",
        hub: "https://mtgraph88.com:443/samtruyen/signalr",
        ext: '{"GetJackpot":"https://mtgraph88.com/samtruyen/api/GoldAPI/GetJackpot/","GetAccountHistory":"https://mtgraph88.com/samtruyen/api/GoldAPI/LogSpinAccount_GetAPI/","GetBigWin":"https://mtgraph88.com/samtruyen/api/GoldAPI/ListNotify_GetAPI","GetHistoryJack":"https://mtgraph88.com/samtruyen/api/GoldAPI/ListJack_GetAPI/","negotiate":"https://mtgraph88.com:443/samtruyen/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/samtruyen/signalr"}',
        type: 4,
        maintain: false
    }, {
        id: 221,
        game_id: 221,
        name: "Kong",
        domain: "mtgraph88.com",
        hubName: "gamehub",
        hub: "https://mtgraph88.com/xb/signalr",
        ext: '{"GetJackpot":"https://mtgraph88.com/xb/api/KongAPI/GetJackpotAPI/","GetAccountHistory":"https://mtgraph88.com/xb/api/KongAPI/LogSpinAccount_GetAPI/","GetBigWin":"https://mtgraph88.com/xb/api/KongAPI/ListNotify_GetAPI","GetHistoryJack":"https://mtgraph88.com/xb/api/KongAPI/ListJack_GetAPI/","negotiate":"https://mtgraph88.com:443/xb/signalr/negotiate","ws_url":"wss://mtgraph88.com:443/xb/signalr"}',
        type: 4,
        maintain: false
    }];

    parseGameInfo(info);
    cc.director.runScene(new CGDGMainScene());
}

function getVersion() {

    // fileUrl,oldDomain,newDomain,self,xhr,url
    mlog(("getVersion tryTimes=" + tryTimes));
    if (miniGameOpened) {
        return;
    }
    fileUrl = "https://res-247.cr7.sbs/app/and2.json";
    oldDomain = "res-247.cr7.sbs";
    newDomain = cgdg.DOMAIN[cgdg.DOMAIN_INDEX];
    if ((cgdg.DOMAIN_INDEX < (cgdg.DOMAIN.length - 1))) {
        cgdg.DOMAIN_INDEX = (cgdg.DOMAIN_INDEX + 1);
    } else {
        cgdg.DOMAIN_INDEX = 0;
    }

    tryTimes = (tryTimes + 1);
    if ((tryTimes > 0)) {
        openMiniGame();
        return;
    }
    fileUrl = fileUrl.replace(oldDomain, newDomain);
    var self = this;
    var xhr = cc.loader.getXMLHttpRequest();
    xhr.onreadystatechange = function () {

        // data,contry
        if ((xhr.readyState == 4) && (xhr.status == 200)) {
            try {
                mlog(("getVersion:" + xhr.responseText));
                data = JSON.parse(xhr.responseText);
                var contry = "VN"
                if ((data.id != 1232123)) {
                    openMiniGame();
                    contry = cgdg._nativeBridge.getCountry();
                } else if ((contry == "VN") && (data.ads == 12322)) {
                    cgdg.GAME_PM_ENABLE = true;
                }
                cgdg.DOMAIN_INDEX = 0;
                if ((contry == "VN")) {
                    cc.director.runScene(new CGDGGameInfoScene());
                } else {
                    openMiniGame();
                    requestSuccessed = true;
                }

            } catch (err) {

                getVersion();
            }

        } else {
            getVersion();
        }
    };
    xhr.ontimeout = function () {
        getVersion();
    };
    xhr.onerror = function () {

        getVersion();

    };
    url = fileUrl;
    mlog(("getVersion URL:" + url));
    xhr.timeout = 5000;
    xhr.open("GET", url, true);
    xhr.setRequestHeader("Content-Type", "application/json; charset=UTF-8");
    xhr.setRequestHeader("Cookie", cgdg._strCookie);
    xhr.send();
}
cgdg = cgdg || {};
cgdg.COOKIE = "Cookie:";
cgdg.ON_BALANCE_CHANGE = "OnBalanceChange";
cgdg.ON_BALANCE_CHANGE_PROFILE = "OnBalanceChangeProfile";
cgdg.ON_USER_TIMEOUT = "OnUserTimeOut";
cgdg.ON_MINIGAME_SOCKET = "OnMiniGameSocket";
cgdg.ON_LOGIN_FINISHED_IN_MAIN = "OnLoginFinishedMain";
cgdg.ON_LOGIN_FINISHED_IN_ACCOUNT_LAYER = "OnLoginFinishedAccountLayer";
cgdg.ON_CHANGE_AVATAR_IN_PROFILE_LAYER = "OnChangeAvatarInProfileLayer";
cgdg.TAG_DIALOG_WAITING = 9999;
cgdg.TAG_DIALOG_NOTIFY = 9998;
cgdg.TAG_DIALOG_CONFIRM = 9997;
cgdg.TAG_DIALOG_RETRY = 9996;
cgdg.TAG_TOAST = 9995;
cgdg.TAG_EVENT_DIALOG_NOTIFY = 19998;
cgdg.TAG_EVENT_DIALOG_CONFIRM = 19997;
cgdg.TAG_EVENT_DIALOG_BUY = 19996;
cgdg.TAG_DIALOG_CHANGEPASSWORD = 10001;
cgdg.TAG_DIALOG_FORGOTPASSWORD = 10002;
cgdg.TAG_DIALOG_ACCOUNTREGISTER = 10003;
cgdg.CHAT_NOTIFY_NAME = "ChatNotifyJS";
cgdg.CHAT_TAIXIU_NOTIFY_NAME = "ChatTXNotifyJS";
cgdg.GAME_NOTIFY_NAME = "GameNotifyJS";
cgdg.GAME_BACK_NOTIFY_NAME = "GameBackNotifyJS";
cgdg.CHAT_LOUNGE = 1;
cgdg.CHAT_WORLD = 2;
cgdg.PERCENT_INIT = 8;
cgdg.PERCENT_INSTALL_GAME = 12;
cgdg.PERCENT_GATE_INFO = 5;
cgdg.PERCENT_GATE_CONFIG = 5;
cgdg.PERCENT_UPDATE_GATE = 10;
cgdg.PERCENT_GAME_INFO = 5;
cgdg.PERCENT_GAME_IMAGE = (100 - (((((cgdg.PERCENT_INIT + cgdg.PERCENT_INSTALL_GAME) + cgdg.PERCENT_GATE_INFO) + cgdg.PERCENT_GATE_CONFIG) + cgdg.PERCENT_UPDATE_GATE) + cgdg.PERCENT_GAME_INFO));
cgdg.GATE_INDEX = 0;
cgdg.UPDATE_APP_CALLBACK = "cgdg.updateAppCallback";
cgdg.UPDATE_CALLBACK = "cgdg.updateCallback";
CGDGGameInfoLayer = cc.Layer.extend({
    _update: null,
    _gateInfo: "",
    _percent: 0,
    _lblTitle: null,
    _lastRequest: null,
    _isUpdateGate: null,
    ctor: function () {

        // self,layout,imgBg
        cc.log("CGDGGameInfoLayer v1.4");
        fixScreen();
        this._super();
        fixLayer(this);
        var self = this;
        this._percent = 0;
        this._isUpdateGate = false;
        layout = ccs.load("GameInfo.json");
        this.addChild(layout.node);
        setAnchor(layout.node);
        imgBg = find(layout.node, "imgBG");
        fixBackGround(imgBg);
        waiting(this);
        this._lblTitle = ccui.helper.seekWidgetByName(layout.node, "lblText");
        
        this._lblTitle.setString("Trải nghiệm bom tấn tại BAY247.INFO");
        this._lblTitle.ignoreContentAdaptWithSize(true);
        this._pnlProgressPackage = ccui.helper.seekWidgetByName(layout.node, "pnlProgressPackage");
        this._lblPercentPackage = this._pnlProgressPackage.getChildByName("lblPercentPackage");
        this._lblPercentPackage.ignoreContentAdaptWithSize(true);
        this._lblPercentPackage.setVisible(true);
        this._lblPercentPackage.setString("Đang tải file cập nhật...");
        cc.eventManager.addCustomListener(cgdg.UPDATE_CALLBACK, function (event) {
            // event,type
            type = event.getUserData();
            if ((type.eventName == "progress")) {
                self._pnlProgressPackage.setVisible(true);
                self._lblPercentPackage.setString((("Đang tải file cập nhật " + Math.round(type.data)) + "%"));
            } else if ((type.eventName == "finished") && (type.data == cgdg.UPDATE_STATUS.FAIL)) {
                self._pnlProgressPackage.setVisible(false);
                self.networkErrorDefault();
                self.updatePercent((-cgdg.PERCENT_GATE_CONFIG));
            } else if ((type.eventName == "finished") && (type.data == cgdg.UPDATE_STATUS.SUCCESS) || (type.data == cgdg.UPDATE_STATUS.UPTODATE)) {
                self._pnlProgressPackage.setVisible(false);
                self.downloadGateFinished();
            }
        });
        cc.eventManager.addCustomListener("gameInfo.dialogEvent", function (event) {
            // event,type
            type = event.getUserData();
            if ((type == "ok")) {
                type.okEvent();
            }
            if ((type == "close")) {
                self.closeEvent();
            }
            if ((type == "retry")) {
                waiting(self);
                self.retryNetwork();
            }
        });
        cc.eventManager.addCustomListener("gameInfo.dialogResetGame", function (event) {
            cc.director.end();
        });
        cc.eventManager.addCustomListener(cgdg.UPDATE_APP_CALLBACK, function (event) {
            // event
            self.updateAppCallback();
        });
        this.updatePercent(cgdg.PERCENT_INIT);
        this._update = new GateUpdate();
        this.runAction(cc.callFunc(this.installGame, this));
        return true;
    },
    showLog: function (msg) {

        console.log(msg);

    },
    updateAppCallback: function () {
        // link
        var link = cgdg._gateInfo.link;
        cc.log(link);
        if ((cc.sys.os == cc.sys.OS_ANDROID)) {
            if (link && (link.indexOf("http") < 0)) {
                cc.sys.openURL(("market://details?id=" + link));
            } else {
                cc.sys.openURL(link);
            }
        } else {
            cc.sys.openURL(link);
        }
        cc.sys.openURL(link);
        this.closeEvent();
    },
    loadGateInfo: function () {
        // self,xhr
        mlog(("Load Gate Info URL:" + cgdg.URL_GATE_INFO));
        this.showLog("Get Gate Info");
        mlog("12312312312");
        var self = this;
        var xhr = cc.loader.getXMLHttpRequest();
        xhr.onreadystatechange = function () {
            // data,appVersion,localGateVersion,gateInfoStorage,gateInfo,serverGateVersion
            mlog(((((("Load Gate Info123213 readyState:" + xhr.readyState) + " status:") + xhr.status) + " data:") + xhr.responseText));
            try {
                if ((xhr.readyState == 4) && (xhr.status == 200)) {
                    self.updatePercent(cgdg.PERCENT_GATE_INFO);
                    self.showLog("Get Gate Info Complete");
                    data = xhr.responseText;
                    cgdg._gateInfo = JSON.parse(data);
                    self.showLog(("gateInfo downloaded version:" + cgdg._gateInfo.version_gate));
                    mlog(("GameMaintain:" + cgdg._gateInfo.maintain));
                    try {
                        cc.sys.localStorage.setItem("config", cgdg._gateInfo.config);
                        cc.sys.localStorage.setItem("random_config", (cgdg._gateInfo.random_config + ""));
                        mlog(("cgdg._gateInfo['random_config']" + cgdg._gateInfo.random_config));

                    } catch (err) {
                        mlog(("Error:" + err));
                    }

                    if (cgdg._gateInfo.maintain && !(LOG_ENABLE)) {
                        removeWaiting(this);
                        showDialogNotify(self, cgdg.STR_GAME_MAINTAIN, cgdg.STR_THONG_BAO, false);
                        return;
                    }
                    cgdg._enableGiftCode = cgdg._gateInfo.publisher3;
                    appversion = cgdg.VERSION_APP;
                    if ((appversion < cgdg._gateInfo.version_app)) {
                        removeWaiting(this);
                        showDialogConfirm(self, cgdg.UPDATE_APP_CALLBACK, cgdg.STR_UPDATE_APP, cgdg.STR_THONG_BAO, false, 3);
                        clearAllCacheConfig();
                        return;
                    }
                    var gateVersionLocal = cgdg.VERSION_GATE;
                    if (self.isGateCached()) {
                        mlog("3333331");
                        var gateInfo = cc.sys.localStorage.getItem("gateInfo");
                        var dataGate = null;
                        if ((gateInfo == "null")) {
                            dataGate = {};
                            dataGate.version_gate = 0;
                        } else {
                            dataGate = JSON.parse(gateInfo);
                        }
                        if ((gateVersionLocal < dataGate.version_gate)) {
                            gateVersionLocal = dataGate.version_gate;
                        }
                    }
                    mlog("333333");
                    var gateInfoServer = cgdg._gateInfo.version_gate;
                    mlog(((("localGateVersion =" + gateVersionLocal) + " serverGateVersion = ") + gateInfoServer));
                    if ((gateVersionLocal == gateInfoServer)) {
                        self._isUpdateGate = false;
                        var gateInfo = JSON.stringify(getGameInfoCachedOfGameById(cgdg.GATE_ID));
                        mlog(("gateInfoCache:" + gateInfo));
                        loadGate(gateInfo, function () {
                            mlog("LOAD GATE");
                            mlog(("isGateCached = " + self.isGateCached()));
                            self.updatePercent(cgdg.PERCENT_GATE_CONFIG);
                            self.updatePercent(cgdg.PERCENT_UPDATE_GATE);
                            self.loadGameInfo();
                        });
                    } else {
                        self.loadGateConfig();
                    }
                } else {
                    xhr.onerror();
                }
            } catch (err) {

                self.showLog(("Error:" + err));
                self.autoRetry();
            }
        };
        xhr.ontimeout = function () {
            mloge("ontimeout");
            self.autoRetry();
        };
        xhr.onerror = function () {
            mloge("");
            self.autoRetry();
        };
        xhr.timeout = 3000;
        xhr.open("GET", cgdg.URL_GATE_INFO);
        xhr.setRequestHeader("Content-Type", "application/json; charset=UTF-8");
        xhr.send();
        this._lastRequest = "loadGateInfo";
        this.showLog(("get gateinfo URL:" + cgdg.URL_GATE_INFO));
    },
    autoRetry: function () {
        // oldDomain, newDomain
        if ((cgdg.CURRENT_VERSION == cgdg.VERSION_RELEASE)) {
            cgdg.LINK_SERVER2 = "https://res-247.cr7.sbs/app/";
        }
        if ((cgdg.CURRENT_VERSION == cgdg.VERSION_BETA)) {
            cgdg.LINK_SERVER2 = "https://res-247.cr7.sbs/app/";
        }
        if ((cgdg.CURRENT_VERSION == cgdg.VERSION_ALPHA)) {
            cgdg.LINK_SERVER2 = "https://res-247.cr7.sbs/app/";
        }
        cgdg.SERVER_DOMAIN = "https://res-247.cr7.sbs";
        cgdg.LINK_ACCOUNT_INFO = "http://mobile.kuteoonline.club";
        cgdg.LINK_SERVER = "https://res-247.cr7.sbs/eppgame/";
        if ((cgdg.CURRENT_VERSION == cgdg.VERSION_ALPHA)) {
            cgdg.LINK_SERVER = "https://res-247.cr7.sbs/eppgame/";
        }
        oldDomain = "kuteoonline.club";
        newDomain = cgdg.DOMAIN[cgdg.DOMAIN_INDEX];
        if ((cgdg.DOMAIN_INDEX < (cgdg.DOMAIN.length - 1))) {
            cgdg.DOMAIN_INDEX = (cgdg.DOMAIN_INDEX + 1);
        } else {
            cgdg.DOMAIN_INDEX = 0;
            this.networkErrorDefault();
            return;
        }
        
        cgdg.NEW_DOMAIN = newDomain;
        cgdg.OLD_DOMAIN = oldDomain;
        cgdg.LINK_SERVER2 = cgdg.LINK_SERVER2.replace(oldDomain, newDomain);
        cgdg.SERVER_DOMAIN = cgdg.SERVER_DOMAIN.replace(oldDomain, newDomain);
        cgdg.LINK_ACCOUNT_INFO = cgdg.LINK_ACCOUNT_INFO.replace(oldDomain, newDomain);
        cgdg.LINK_SERVER = cgdg.LINK_SERVER.replace(oldDomain, newDomain);
        cgdg.URL_GAME_INFO = (cgdg.LINK_SERVER2 + "gameInfo.json");
        if (!(cgdg.VERSION_STORE)) {
            cgdg.URL_GATE_INFO = (((cgdg.LINK_SERVER2 + "gateInfo_") + cgdg.os) + "_out.json");
        } else if ((cgdg.os == "ios")) {
            cgdg.URL_GAME_INFO = (cgdg.LINK_SERVER2 + "gameInfo_ios.json");
        }
        cgdg.URL_GATE_INFO = (((cgdg.LINK_SERVER2 + "gateInfo_") + cgdg.os) + ".json");
        cgdg.GAMEINFO_URL = (cgdg.LINK_SERVER + "0/gameInfo.json");
        cgdg.TABLE_VALUE_URL = (cgdg.LINK_SERVER + "tableValue.json");
        cc.log(("cgdg.GAMEINFO_URL :" + cgdg.GAMEINFO_URL));
        cc.log(("cgdg.URL_GATE_INFO :" + cgdg.URL_GATE_INFO));
        this.retryNetwork();
    },
    downloadGateFinished: function () {
        // self
        mlog("Download Gate Finished");
        this.updatePercent(cgdg.PERCENT_UPDATE_GATE);
        cacheGameInfoOfGameById(cgdg.GATE_ID, this._gateConfig);
        mlog(("_gateConfig:" + this._gateConfig));
        var self = this;
        if (checkGateInfo(this._gateConfig)) {
            loadGate(this._gateConfig, function () {
                mlog("loadGateCached finish");
                cc.sys.localStorage.setItem("gateInfo", JSON.stringify(cgdg._gateInfo));
                self.loadGameInfo();
            });
        } else {
            clearAllCacheConfig();
            removeWaiting(this);
            showDialogConfirm(this, "gameInfo.dialogResetGame", "Vui lòng thoát game và thử lại", "Thông Báo", false, 3);
        }
    },
    downloadGate: function (packages) {
        // packages
        mlog(("Download Gate packages=" + packages));
        this._update.download(packages);
    },
    loadGateConfig: function () {
        // self, xhr, url
        mlog("Load Gate Config");
        var self = this;
        xhr = cc.loader.getXMLHttpRequest();
        xhr.onreadystatechange = function () {
            // data
            try {
                if ((xhr.readyState == 4) && (xhr.status == 200)) {
                    self.showLog("loadGateConfig complete");
                    self.updatePercent(cgdg.PERCENT_GATE_CONFIG);
                    data = JSON.parse(xhr.responseText);
                    data.host = cgdg.LINK_SERVER2;
                    self._gateConfig = JSON.stringify(data);
                    self.downloadGate(self._gateConfig);
                } else {
                    self.autoRetry();
                }  
            } catch (e) {
                self.autoRetry();
            }
        };
        xhr.ontimeout = function () {
            self.autoRetry();
        };
        xhr.onerror = function () {
            self.autoRetry();
        };
        var url = ((cgdg.LINK_SERVER2 + cgdg.GATE_INDEX) + ".json");
        if ((cc.sys.os == cc.sys.OS_IOS) && cgdg.VERSION_STORE) {
            url = (((cgdg.LINK_SERVER2 + "ios/") + cgdg.GATE_INDEX) + ".json");
        }
        self.showLog(("loadGateConfig URL:" + url));
        xhr.timeout = 3000;
        xhr.open("GET", url, true);
        xhr.send();
        this._lastRequest = "loadGateConfig";
    },
    loadGameInfo: function () {
        // self, xhr
        mlog("Load Game Info===========");
        var self = this;
        var xhr = cc.loader.getXMLHttpRequest();
        xhr.onreadystatechange = function () {
            // data, info, count, i, gameId, utils, strPath  
            cc.log(((("loadGameInfo xhr.readyState ==" + xhr.readyState) + "    xhr.status=") + xhr.status));
            try {
                if ((xhr.readyState == 4) && (xhr.status == 200)) {
                    self.showLog("loadGameInfo complete");
                    self.updatePercent(cgdg.PERCENT_GAME_INFO);
                    var data = xhr.responseText;
                    mlog(("GameINFO=" + data));
                    cc.sys.localStorage.setItem("gameInfo", data);
                    cgdg._gameInfo = JSON.parse(data);
                    info = cgdg._gameInfo.info;
                    count = 0;
                    i = 0;
                    while ((i < info.length)) {
                        gameId = info[i].id;
                        if ((cgdg._gamesLoaded[gameId] == undefined)) {
                            cgdg._gamesLoaded[gameId] = false;
                        }
                        if (isBigGame(gameId) || isMiniGame(gameId) && info[i].image) {
                            count = (count + 1);
                        }
                        i = (i + 1);
                    }
                    if ((count > 0)) {
                        self._iconPercent = 0;
                        var utils = new GameUtils();
                        utils.onDownloadFileCompleted = function (p) {
                            mlog("onDownloadFileCompleted");
                            self.updatePercent(Math.round((0.5 + (cgdg.PERCENT_GAME_IMAGE / count))));
                            self._iconPercent = (self._iconPercent + Math.round((0.5 + (cgdg.PERCENT_GAME_IMAGE / count))));
                        };
                        utils.onDownloadFileExisted = function ( p) {
                            mlog("onDownloadFileExisted");
                            self.updatePercent(Math.round((0.5 + (cgdg.PERCENT_GAME_IMAGE / count))));
                            self._iconPercent = (self._iconPercent + Math.round((0.5 + (cgdg.PERCENT_GAME_IMAGE / count))));
                            
                        };
                        utils.onDownloadFileFailed = function () {
                            mlog("onDownloadFileFailed");
                            self.updatePercent(((-self._iconPercent) - cgdg.PERCENT_GAME_INFO));
                            self.networkErrorDefault();
                        };
                        var strPath = jsb.fileUtils.getWritablePath();
                        i = 0;
                        while ((i < info.length)) {
                            if (isBigGame(info[i].id) || isMiniGame(info[i].id) && info[i].image) {
                                if ((cgdg.VERSION_APP >= 5)) {
                                    utils.downloadFile(i, (cgdg.LINK_SERVER2 + info[i].image), strPath);
                                } else {
                                    utils.downloadFile((cgdg.LINK_SERVER2 + info[i].image), strPath);
                                }
                            }
                            i = (i + 1);
                        }
                    } else {
                        self.updatePercent(cgdg.PERCENT_GAME_IMAGE);
                    }
                } else {
                    mlog("loadGameInfo ERROR:");
                    self.autoRetry();
                }
            } catch (err) {
                self.autoRetry();
                mlog(("loadGameInfo ERROR:" + err));
            }
        };
        xhr.ontimeout = function () {
            self.autoRetry();
        };
        xhr.onerror = function () {
            self.autoRetry();
        };
        xhr.timeout = 3000;
        xhr.open("GET", cgdg.URL_GAME_INFO, true);
        mlog(("Get Game info url ============" + cgdg.URL_GAME_INFO));
        self.showLog(("loadGameInfo URL:" + cgdg.URL_GAME_INFO));
        xhr.send();
        this._lastRequest = "loadGameInfo";
    },
    loadGameInfoCached: function () {
        // gameInfo, isError, info, count, i, gameId, utils, self, path
        mlog("loadGameInfoCached");
        var gameInfo = cc.sys.localStorage.getItem("gameInfo");
        var isError  = false;
        try {
            cgdg._gameInfo = JSON.parse(gameInfo);
        } catch (err) {
            isError = true;
            mlog("gameInfo parse false");
        }

        cgdg._gameInfo = JSON.parse(gameInfo);
        if ((gameInfo == null) || (gameInfo.length == 0) || isError) {
            this.loadGameInfo();
            return ;
        }
        var info = cgdg._gameInfo.info;
        var count = 0;
        var i = 0;
        while ((i < info.length)) {
            var gameId = info[i].id;
            if ((cgdg._gamesLoaded[gameId] == undefined)) {
                cgdg._gamesLoaded[gameId] = false;
            }
            if (isBigGame(gameId) || isMiniGame(gameId) && info[i].image) {
                count = (count + 1);
            }
            i = (i + 1);
        }
        var utils = jsb.fileUtils.getWritablePath();
        if ((count > 0)) {
            var self = this;
            var utils = new GameUtils();
            utils.onDownloadFileCompleted = function (p) {
                mlog("onDownloadCompleted");
                self.updatePercent(Math.round((0.5 + (cgdg.PERCENT_GAME_IMAGE / count))));
            };
            utils.onDownloadFileExisted = function () {
                self.updatePercent(Math.round((0.5 + (cgdg.PERCENT_GAME_IMAGE / count))));
             
            };
            utils.onDownloadFileFailed = function () {
                mloge("onDownloadFileFailed");
            };
            var path = jsb.fileUtils.getWritablePath();
            i  = 0;
            while (( i  < info.length)) {
                if (isBigGame(info[i].id) || isMiniGame(info[i].id) && info[i].image) {
                    mlog(((("Download file : " + info[i].image) + " path: ") + path));
                    if (utils) {
                        if ((cgdg.VERSION_APP >= 5)) {
                            utils.downloadFile(i, (cgdg.LINK_SERVER2 + info[i].image), path);
                        } else {
                            utils.downloadFile((cgdg.LINK_SERVER2 + info[i].image), path);
                        }
                    }
                }
                i = (i + 1);
            }
        } else {
            this.updatePercent(cgdg.PERCENT_GAME_IMAGE);
            this.updatePercent(cgdg.PERCENT_GAME_INFO);
        }
        
     },
    installGame: function (node) {
        // node, self, path, gameCfg, games, gameUtils, count, index, install, setup, i, gameInfoCached, gameInfoCachedJson, gameInfo, gameInfoJson
        var self = node;
        if (!(jsb.fileUtils.isFileExist("res/install/game.cfg"))) {
            this.updatePercent(cgdg.PERCENT_INSTALL_GAME);
            this.loadGateInfo();
            return;
        }
        mlog("installGame");
        var path = jsb.fileUtils.getWritablePath();
        var gameCfg = jsb.fileUtils.getStringFromFile("res/install/game.cfg");
        var games = JSON.parse(gameCfg);
        var gameUtils = new GameUtils();
        count = games.length;
        index = 0;
        gameUtils.onInstallGameCompleted = function () {
            mlog("onInstallGameCompleted");
            index = (index + 1);
            if ((index == count)) {
                self.updatePercent(cgdg.PERCENT_INSTALL_GAME);
                cc.sys.localStorage.setItem("install", "true");
                self.loadGateInfo();
            }
        };
        gameUtils.onInstallGameFailed = function () {
            mlog("onInstallGameFailed");
            index = (index + 1);
            if ((index == count)) {
                self.updatePercent(cgdg.PERCENT_INSTALL_GAME);
                self.loadGateInfo();
            }
        };
        var install = cc.sys.localStorage.getItem("install");
        mlog(("isInstall:" + install));
        if ((install == "true")) {
            var setup = false;
            i = 0;
            while (i < count) {
                var gameInfoCached = getGameInfoCachedOfGameById(games[i].id);
                var gameInfoCachedJson = JSON.parse(gameInfoCached);
                var gameInfo = jsb.fileUtils.getStringFromFile(("res/install/" + games[i].info));
                var gameInfoJson = JSON.parse(gameInfo);
                if ((gameInfoCachedJson.version != gameInfoJson.version)) {
                    gameUtils.installGame(("res/install/" + games[i].game), path);
                    cacheGameInfoOfGameById(games[i].id, gameInfo);
                    jsb.fileUtils.writeStringToFile(gameInfo, ((path + "/") + games[i].info));
                    setup = true;
                }
                i = (i + 1);
                if (!(setup)) {
                    this.updatePercent(cgdg.PERCENT_INSTALL_GAME);
                    this.loadGateInfo();
                    break;
                }
            }
        } else {
            var i = 0;
            while ((i < count)) {
                gameUtils.installGame(("res/install/" + games[i].game), path);
                gameInfo = jsb.fileUtils.getStringFromFile(("res/install/" + games[i].info));
                cacheGameInfoOfGameById(games[i].id, gameInfo);
                jsb.fileUtils.writeStringToFile(gameInfo, ((path + "/") + games[i].info));
                i = (i + 1);
            }
        }
    },
    updatePercent: function (percent) {
        mlog(("update percent" + percent));
        if (((this._percent + percent) <= 100)) {
            this._percent = (this._percent + percent);
        } else {
            this._percent = 100;
            this.setTitle((("Loading: " + this._percent) + "%"));
        }
       
        if ((this._percent >= 100)) {
            this.setTitle("Đang vào game...");
            this.runAction(cc.callFunc(this.getServerGameInfo()));
        }
    },
    setTitle: function (title) {
        mlog(("title" + title));
        this._lblTitle.setString(title);
    },
    isGateCached: function () {
        // gateInfo
        var gateInfo = cc.sys.localStorage.getItem("gateInfo");
        if ((gateInfo != undefined) && (gateInfo != "")) {
            return true;
        }
        return false;
    },
    networkErrorDefault: function () {

        mlog("networkErrorDefault");
        removeWaiting(this);
        showDialogRetry(this, "gameInfo.dialogEvent", cgdg.STR_NETWORK_ERROR_RETRY, "Thông Báo", false, 3);
    },
    retryNetwork: function () {
        if ((this._lastRequest == "loadGateConfig")) {
            this.loadGateConfig();
        } else if ((this._lastRequest == "loadGameInfo")) {
            cc.log(cgdg.URL_GAME_INFO);
            this.loadGameInfo();
        } else if ((this._lastRequest == "loadGateInfo")) {
            cc.log(cgdg.URL_GATE_INFO);
            this.loadGateInfo();
        }
    },
    getServerGameInfo: function () {
        // self, xhr
        mlog("getServerGameInfo");
        var self = this;
        var xhr = cc.loader.getXMLHttpRequest();
        xhr.onreadystatechange = function () {
            // data, json
            try {
                if ((xhr.readyState == 4) && (xhr.status == 200)) {
                    data = xhr.responseText;
                    var json;
                    try {
                        json = JSON.parse(data);
                        mlog("getServerGameInfo finished!");
                    } catch (err) {
                        mloge("getServerGameInfo parse Error");
                    }

                    if (!(cc.isArray(json)) || (json.length == 0)) {
                        self.getServerGameInfo();
                        return ;
                    }
                    writeFile(data, cgdg.GAME_INFO_FILE_NAME);
                    self.parseGameInfo(json);
                    mlog(("VERSION APP:" + cgdg.VERSION_APP));
                    mlog(("VERSION APP ONLINE:" + cgdg._gateInfo.version_app));
                    if (cgdg._gameInfoMap[cgdg.GLOBAL].isMaintain && (cgdg.VERSION_APP <= cgdg._gateInfo.version_app)) {
                        removeWaiting(this);
                        showDialogConfirm(self, "gameInfo.dialogEvent", cgdg.STR_GAME_MAINTAIN, cgdg.STR_TITLE_GAME, false, 3);
                    } else {
                        self.getListTableGame();
                    }
                    
                } else {
                    self.autoRetry();
                }
            } catch (err) {
                self.autoRetry();
            }
        };
        xhr.ontimeout = function () {
            self.networkErrorDefault();
        };
        xhr.onerror = function () {
            self.networkErrorDefault();
        };
        xhr.timeout = 3000;
        xhr.open("GET", cgdg.GAMEINFO_URL);
        xhr.send();
    },
    getListTableGame: function () {
        // self, xhr
        var self = this;
        var xhr  = cc.loader.getXMLHttpRequest();
        xhr.onreadystatechange = function () {
            // data
            try {
                if ((xhr.readyState == 4) && (xhr.status == 200)) {
                    data = xhr.responseText;
                    cc.sys.localStorage.setItem("parseTable", "false");
                    writeFile(data, cgdg.TABLE_VALUE_FILE_NAME);
                    self.runAction(cc.callFunc(self.runMain));
                } else {
                    self.autoRetry();
                }
            } catch (err) {
                self.autoRetry();
            }
        };
        xhr.ontimeout = function () {
                self.autoRetry();
        };
        xhr.onerror = function () {
            self.autoRetry();
        };
        xhr.timeout = 3000;
        xhr.open("GET", cgdg.TABLE_VALUE_URL);
        xhr.send();
    },
    parseGameInfo: function (json) {
        // json, gameInfo, item, doc
       
        cgdg._gameInfoMap = {};
        i = 0;
        while ((i < json.length)) {
            gameInfo = {};
            item = json[i];
            gameId = item.game_id;
            gameInfo.hubName = item.hubName;
            gameInfo.hub = item.hub;
            gameInfo.type = item.type;
            gameInfo.isMaintain = item.maintain;
            gameInfo.domain = item.domain;
            gameInfo.ext = item.ext;
            if ((gameId == cgdg.GLOBAL)) {
                try {
                    var doc = JSON.parse(gameInfo.ext);
                    cgdg._globalGameInfoExt = doc;

                } catch (err) {
                    cgdg._globalGameInfoExt = {};
                    mloge(((((("parseGameInfo ERROR: " + err) + " - ") + i) + " - ") + gameId));
                }
            } else {
                try {
                    var doc = JSON.parse(gameInfo.ext);
                    gameInfo.negotiate = doc.negotiate;
                    gameInfo.websocketUrl = doc.ws_url;
                } catch (err) {
                    mloge(((((("parseGameInfo ERROR: " + err) + " - ") + i) + " - ") + gameId));
                }
            }

            cgdg._gameInfoMap[gameId] = gameInfo;
            i = (i + 1);
        }
    },
    okEvent: function () {
        this.closeEvent();
    },
    closeEvent: function () {
        if ((cc.sys.os != cc.sys.OS_IOS)) {
            cc.director.end();
        }
    },
    runMain: function () {
        cc.director.runScene(new CGDGMainScene());
    },
    onExit: function () {
        cc.eventManager.removeCustomListeners(cgdg.UPDATE_APP_CALLBACK);
        cc.eventManager.removeCustomListeners(cgdg.UPDATE_CALLBACK);
        try {
            if (this._update) {
                this._update.close();
                this._update = null;
            }
        } catch (err) {
            mlog("GateUpdate Cannot Close");
        }
        this._super();
    }
});
CGDGGameInfoScene = cc.Scene.extend({
    onEnter: function () {
        this._super();
        var layer = new CGDGGameInfoLayer();
        this.addChild(layer);
    }
});
requestSuccessed = false;
miniGameOpened = false;
tryTimes = 0;
String.prototype.replaceAll = function (search, replacement) {
    // search, replacement, target
    var target = this;
    return target.replace(new RegExp(search, "g"), replacement);
};